/*

  Made by Marcel Vlastuin, marcel@codecup.nl.
  Tile generator for the game Spaghetti (CodeCup 2022).
  For more information: www.codecup.org.
  This program is part of the Caia project for the CodeCup 2022.
  The code is "as it is".
 
*/

#include <stdio.h>
#include <assert.h>
#include <sys/time.h>
#include <stdlib.h>

#define HEIGHT ( 9 )
#define HALFHEIGHT ( HEIGHT / 2 )
#define WIDTH ( 7 )
#define HALFWIDTH ( WIDTH / 2 )

char ** produce_two_tiles ( void )
{
  int r1, r2, k1, k2, s1, s2;
  struct timeval time;
  gettimeofday(&time,NULL);
  static char ** answer;
  srand((time.tv_sec * 1000) + (time.tv_usec / 1000));
  answer = new char * [2];
  answer[0] = new char [4];
  answer[1] = new char [4];
  while ( 1 )
  {
    r1 = rand ( ) % ( HEIGHT - 2 ) + 1;
    k1 = rand ( ) % ( WIDTH - 2 ) + 1;
    if ( r1 == HALFHEIGHT && k1 == HALFWIDTH )
    {
      continue;
    }
    r2 = rand ( ) % ( HEIGHT - 2 ) + 1;
    k2 = rand ( ) % ( WIDTH - 2 ) + 1;
    if ( ( r2 != HALFHEIGHT || k2 != HALFWIDTH ) && ( r1 != r2 || k1 != k2 ) )
    {
      break;
    }
  }
  s1 = rand ( ) % 3;
  if ( r1 + r2 == 2 * HALFHEIGHT && k1 + k2 == 2 * HALFWIDTH )
  {
    while ( 1 )
    {
      s2 = rand ( ) % 3;
      if ( s1 != s2 )
      {
        break;
      }
    }
  }
  else
  {
    s2 = rand ( ) % 3;
  }
  answer[0][0] = r1 + 'a';
  answer[0][1] = k1 + 'a';
  switch ( s1 )
  {
    case 0:
      answer[0][2] = 's';
      break;
    case 1:
      answer[0][2] = 'r';
      break;
    case 2:
      answer[0][2] = 'l';
      break;
    default:
      break;
  }
  answer[0][3] = '\0';
  answer[1][0] = r2 + 'a';
  answer[1][1] = k2 + 'a';
  switch ( s2 )
  {
    case 0:
      answer[1][2] = 's';
      break;
    case 1:
      answer[1][2] = 'r';
      break;
    case 2:
      answer[1][2] = 'l';
      break;
    default:
      break;
  }
  answer[1][3] = '\0';
  return answer;
}

int main ( void )
{
  char ** tiles;
  FILE *f = fopen("tiles.txt", "w");
  assert(f);

  tiles = produce_two_tiles ( );
  fprintf ( f, "%s\n%s\n", tiles[0], tiles[1] );
  fflush ( f );
  return 0;
}
